/*
 * local_search.h
 *
 *  Created on: Dec 17, 2019
 *      Author: pengfei
 */
#include"basic.h"
#ifndef LOCAL_SEARCH_H_
#define LOCAL_SEARCH_H_
void reverse_list (solution & pi);
void update_best_sol(solution &pi,solution &best_p);// the function of the fun is to replace the best solution
void insert_zero(solution & pi,int row,int in_num,int * sequence_table,int & p_pointer,int & n_pointer);
void insert_f(solution & pi,int & row,int & col, int & in_num,int * sequence_table,int & p_pointer,int & n_pointer);
void update_zero_delta(solution & pi,int row,int  col,int in_num,int * sequence_table,int p_pointer,int n_pointer,
	double ** delta_insert,double ** delta_zero,int ** re_pi,int record);
double calculate_length_tour(int *s,int n_v);
double calculat_delta(int u1,int v1,int u2,int v2);
void reverse(int * s, int reverse_1,int reverse_2,int n_v);
double tabu_search_2_opt(int * s,int n_v);
double tabu_search_2(int * s,int n_v,int ** tabu);
void opt_2(solution & pi,int * record_table,int ** tabu,solution & tem_pi);
void initial_delta(double **delta_zero, double **delta_insert,int *s_t,solution &pi);
long int comput_tabu1(solution & pi);
long int comput_tabu2(solution &pi);
long int comput_tabu1_part(solution & pi, int *s_t,int row,int col,int in_num);
long int comput_tabu2_part(solution & pi, int * s_t,int row, int col, int in_num);
void loacl_improve(solution & pi, solution & best_p,int * Hx1,int *Hx2,double ** delta_insert,double ** delta_zero,int ** tabu,
	int *s_t,clock_t start,int time_length,solution & tem_pi);
void main_search(solution &pi,solution &best_p,solution & g_best_p,int *Hx1,int * Hx2,clock_t start, int time_length,
	clock_t & optimal_time,double ** delta_insert,double ** delta_zero,int ** tabu,solution & tem_pi);

#endif /* LOCAL_SEARCH_H_ */



