/*
 * local_search.cpp
 *
 *  Created on: Dec 17, 2019
 *      Author: pengfei
 */
#include"basic.h"
#include"read.h"
#include"perturb_fun.h"
using namespace std;
//extern int ex;
extern int num_v;
extern int v_num;
extern double ** Distance;
extern int *x_y;
//extern int iterations;
extern int record;
void reverse_list (solution & pi)
{
	vector<int >tour;
	int pointer;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=pi.sol[i][0];
		while (pointer!=0)
		{
			tour.push_back(pointer);
			pointer=pi.sol[i][pointer];
		}
		pi.sol_r[i][0]=tour.back();
		tour.pop_back();
		pointer=pi.sol_r[i][0];
		while (tour.size())
		{
			pi.sol_r[i][pointer]=tour.back();
			pointer=pi.sol_r[i][pointer];
			tour.pop_back();
		}
		pi.sol_r[i][pointer]=0;
	}
}
void update_best_sol(solution &pi,solution &best_p)// the function of the fun is to replace the best solution
{
	for (int i=0;i<=v_num-1;i++)
		for (int j=0;j<=num_v;j++)
			best_p.sol[i][j]=pi.sol[i][j];
	best_p.fit=pi.fit;
}
void insert_zero(solution & pi,int row,int in_num,int * sequence_table,int & p_pointer,int & n_pointer)
{
	// insert the new tour
	int tem;
	tem=pi.sol[row][0];
	pi.sol[row][0]=in_num;
	pi.sol[row][in_num]=tem;
	pi.sol_r[row][tem]=in_num;
	pi.sol_r[row][in_num]=0;
	//delete the in_num in previous tour
	p_pointer=pi.sol_r[sequence_table[in_num]][in_num];// a node before inserting node
	n_pointer=pi.sol[sequence_table[in_num]][in_num];// a node after inserting node
	pi.sol[sequence_table[in_num]][p_pointer]=n_pointer;
	pi.sol[sequence_table[in_num]][in_num]=-1;
	pi.sol_r[sequence_table[in_num]][n_pointer]=p_pointer;
	pi.sol_r[sequence_table[in_num]][in_num]=-1;
}

void insert_f(solution & pi,int & row,int & col, int & in_num,int * sequence_table,int & p_pointer,int & n_pointer)
{
	int tem;int tem_2;
	tem=pi.sol[row][col];
	pi.sol[row][col]=in_num;
	pi.sol[row][in_num]=tem;
	tem_2=pi.sol_r[row][tem];
	pi.sol_r[row][tem]=in_num;
	pi.sol_r[row][in_num]=tem_2;
	// completely add and operate delete in_num from previous row.
	p_pointer=pi.sol_r[sequence_table[in_num]][in_num];// a node before inserting node
	n_pointer=pi.sol[sequence_table[in_num]][in_num];// a node after inserting node
	pi.sol[sequence_table[in_num]][p_pointer]=n_pointer;
	pi.sol[sequence_table[in_num]][in_num]=-1;
	pi.sol_r[sequence_table[in_num]][n_pointer]=p_pointer;
	pi.sol_r[sequence_table[in_num]][in_num]=-1;
}
void update_zero_delta(solution & pi,int row,int  col,int in_num,int * sequence_table,int p_pointer,int n_pointer,
	double ** delta_insert,double ** delta_zero,int record)
{
	int new_p_pointer,new_n_pointer;// these two variables are used to record the position of inserting row for in_num
	int previous_row=sequence_table[in_num];// to record the previous row.
	sequence_table[in_num]=row;// update the order of row for all nodes
	new_n_pointer=pi.sol[row][in_num];
	new_p_pointer=pi.sol_r[row][in_num];
	int pointer;
	// enter loop
	for(int i=record-1;i<=num_v;i++)
	{
		if (x_y[i]>0)
			continue;
		for (int j=0;j<=v_num-1;j++)
		{
			if (sequence_table[i]!=row && sequence_table[i]!=previous_row && j!=row && j!=previous_row)
				continue;
			if ((sequence_table[i]==row || sequence_table[i]==previous_row)&&( j!=row && j!=previous_row)&&(i!=p_pointer && i!=n_pointer && i!=in_num && i!=new_n_pointer && i!=new_p_pointer))
				continue;
			if ( sequence_table[i]!=previous_row && j!=row && j==previous_row)// only taking place when
			{
				if (p_pointer==0)
				{
					delta_zero[previous_row][i]=Distance[0][i]+Distance[i][pi.sol[previous_row][0]]-Distance[pi.sol[previous_row][0]][0];
					delta_zero[previous_row][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]]-	Distance[pi.sol[sequence_table[i]][i]][i];
				}
				else
				{
					delta_insert[p_pointer][i]=Distance[p_pointer][i]+Distance[i][n_pointer]-Distance[p_pointer][n_pointer];
					delta_insert[p_pointer][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]];
				}
			}
			if (sequence_table[i]!=row  && j==row && j!=previous_row)
			{
				if (new_p_pointer==0)
				{
					delta_zero[row][i]=Distance[0][i]+Distance[i][pi.sol[row][0]]-Distance[0][pi.sol[row][0]];
					delta_zero[row][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]]-	Distance[pi.sol[sequence_table[i]][i]][i];
				}
				else
				{
					delta_insert[new_p_pointer][i]=Distance[new_p_pointer][i]+Distance[i][in_num]-Distance[new_p_pointer][in_num];
					delta_insert[new_p_pointer][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]];
				}
				delta_insert[in_num][i]=Distance[i][in_num]+Distance[i][new_n_pointer]-Distance[in_num][new_n_pointer];
				delta_insert[in_num][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]];
			}
			if (sequence_table[i]==previous_row && j!=row && j!=previous_row)
			{
				if (i==p_pointer || i==n_pointer)
				{
					pointer=0;
					while (1)
					{
						if (pointer==0)
						{
							delta_zero[j][i]=Distance[0][i]+Distance[i][pi.sol[j][pointer]]-Distance[0][pi.sol[j][pointer]];
							delta_zero[j][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						else
						{
							delta_insert[pointer][i]=Distance[pointer][i]+Distance[i][pi.sol[j][pointer]]-Distance[pointer][pi.sol[j][pointer]];
							delta_insert[pointer][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						pointer=pi.sol[j][pointer];
						if (pointer==0)break;
					}
				}
			}
			if (sequence_table[i]==row && j!=row && j!=previous_row)
			{
				if (i==in_num || i==new_p_pointer || i==new_n_pointer )
				{
					pointer=0;
					while (1)
					{
						if (pointer==0)
						{
							delta_zero[j][i]=Distance[pointer][i]+Distance[i][pi.sol[j][pointer]]-Distance[0][pi.sol[j][pointer]];
							delta_zero[j][i]+=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[pi.sol[sequence_table[i]][i]][i]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						else
						{
							delta_insert[pointer][i]=Distance[pi.sol_r[sequence_table[i]][i]][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]];
							delta_insert[pointer][i]+=Distance[pi.sol[j][pointer]][i]+Distance[pointer][i]-Distance[pointer][pi.sol[j][pointer]];
						}
						pointer=pi.sol[j][pointer];
						if (pointer==0)break;
					}
				}
			}
			if (sequence_table[i]==row && j==previous_row)
			{
				if (i==new_p_pointer || i==new_n_pointer || i==in_num)
				{
					pointer=0;
					while (1)
					{
						if (pointer==0)
						{
							delta_zero[j][i]=Distance[0][i]+Distance[i][pi.sol[j][pointer]]-Distance[0][pi.sol[j][pointer]];
							delta_zero[j][i]+=Distance[pi.sol[sequence_table[i]][i]][pi.sol_r[sequence_table[i]][i]];
							delta_zero[j][i]=delta_zero[j][i]-Distance[i][pi.sol[sequence_table[i]][i]]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						else
						{
							delta_insert[pointer][i]=Distance[i][pointer]+Distance[i][pi.sol[j][pointer]]-Distance[pointer][pi.sol[j][pointer]];
							delta_insert[pointer][i]+=Distance[pi.sol[sequence_table[i]][i]][pi.sol_r[sequence_table[i]][i]];
							delta_insert[pointer][i]=delta_insert[pointer][i]-Distance[pi.sol[sequence_table[i]][i]][i]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						pointer=pi.sol[j][pointer];
						if (pointer==0)break;
					}
				}
			}
			if (sequence_table[i]==row && j==row)
			{
				if (i==in_num)
				{
					pointer=pi.sol[j][0];
					delta_zero[j][i]=Max;
					while (1)
					{
						delta_insert[pointer][i]=Max;
						delta_insert[i][pointer]=Max;
						pointer=pi.sol[j][pointer];
						if (pointer==0)break;
					}
				}
			}
			if (sequence_table[i]==previous_row && j==row)
			{
				if (i==p_pointer || i==n_pointer)
				{
					pointer=0;
					while (1)
					{
						if (pointer==0)
						{
							delta_zero[j][i]=Distance[0][i]+Distance[i][pi.sol[j][pointer]]-Distance[0][pi.sol[j][pointer]];
							delta_zero[j][i]+=Distance[pi.sol[sequence_table[i]][i]][pi.sol_r[sequence_table[i]][i]];
							delta_zero[j][i]=delta_zero[j][i]-Distance[pi.sol[sequence_table[i]][i]][i]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						else
						{
							delta_insert[pointer][i]=Distance[i][pointer]+Distance[i][pi.sol[j][pointer]]-Distance[pointer][pi.sol[j][pointer]];
							delta_insert[pointer][i]+=Distance[pi.sol[sequence_table[i]][i]][pi.sol_r[sequence_table[i]][i]];
							delta_insert[pointer][i]=delta_insert[pointer][i]-Distance[pi.sol[sequence_table[i]][i]][i]-Distance[i][pi.sol_r[sequence_table[i]][i]];
						}
						pointer=pi.sol[j][pointer];
						if (pointer==0)break;
					}
				}
			}
		}
	}
}

double calculate_length_tour(int *s,int n_v)
{
	double path_length=0;
	for (int i=0;i<=n_v-2;i++)
		path_length+=Distance[s[i]][s[i+1]];
	path_length+=Distance[s[n_v-1]][s[0]];
	return path_length;
}
double calculat_delta(int u1,int v1,int u2,int v2)
{
	return(Distance[u1][u2]+Distance[v1][v2]-Distance[u1][v1]-Distance[u2][v2]);
}
void reverse(int * s, int reverse_1,int reverse_2,int n_v)
{
	int temp;
	while (reverse_2 - reverse_1>0)
	{
		temp=s[reverse_1%n_v];
		s[reverse_1%n_v]=s[reverse_2%n_v];
		s[reverse_2%n_v]=temp;
		reverse_1++;
		reverse_2--;
	}
}
double tabu_search_2_opt(int * s,int n_v)// this code employs 2-opt and tabu search to optimize a traditional TSP
{
	int best_s[n_v];
	for (int i=0;i<=n_v-1;i++)
		best_s[i]=s[i];
	double path_length=0;
	path_length=calculate_length_tour(s,n_v);
	int reverse_1,reverse_2;
	double delta_1;
	int v1,v2,u1,u2;
	double min_delta;
	while (1)
	{
		min_delta=Max-1;
		for (int i=0;i<=n_v-1;i++)
		{
			u1=i;
			v1=(i+1)%n_v;
			for (int j=i+2;(j+1)%n_v!=i;j++)
			{
				u2=j%n_v;
				v2=(j+1)%n_v;
				delta_1=calculat_delta(s[u1],s[v1],s[u2],s[v2]);
				if (min_delta>delta_1)
				{
					min_delta=delta_1;
					reverse_1=i+1;
					reverse_2=j;
				}
			}
		}
		if (min_delta<-0.0000000001)
		{
			path_length+=min_delta;
			reverse(s, reverse_1,reverse_2,n_v);
		}
		else
			break;
	}
	int k;
	for (int i=0;i<=n_v-1;i++)
		best_s[i]=s[i];
	for (int i=0;i<=n_v-1;i++)
		if (best_s[i]==0)
		{	k=i;break;}
	s[0]=0;int c=1;
	for (int j=k+1;best_s[j%n_v]!=0;j++)
	{
		s[c]=best_s[j%n_v];c++;
	}
	return path_length;
}
double tabu_search_2(int * s,int n_v,int ** tabu)// this code employs 2-opt and tabu search to optimize a traditional TSP
{
	int a=0;
	for (int i=0;i<=n_v-1;i++)
		if (s[i]>a)
			a=s[i];
	a++;
	for (int i=0;i<=a-1;i++)
		for (int j=0;j<=a-1;j++)
			tabu[i][j]=0;
//	double delta[num_v][num_v];// it should be noticed becasue the delta value is caltulated by exchanging edges, not nodes
	// in the first step a simple 2-opt algorithm should be employed.
	int best_s[n_v];
	for (int i=0;i<=n_v-1;i++)
		best_s[i]=s[i];
	double path_length=0;
	path_length=calculate_length_tour(s,n_v);
	double best_path=path_length;
	int reverse_1,reverse_2;
	double min_delta,min_tabu_delta;
	int num_best,num_tabu_best;
	double delta_1;
	int can_node_1[100],can_node_2[100];
	int can_tabu_node_1[100],can_tabu_node_2[100];
	int step=0;int v1,v2,u1,u2;
	int no_improve=0;
	int tabu_length=ceil (n_v*tabu_search_len);
	while (1)
	{
		step++;
		min_delta=Max-1;min_tabu_delta=Max-1;num_best=0;num_tabu_best=0;
		for (int i=0;i<=n_v-1;i++)
		{
			u1=i;
			v1=(i+1)%n_v;
			for (int j=i+2;(j+1)%n_v!=i;j++)
			{
				u2=j%n_v;
				v2=(j+1)%n_v;
				delta_1=calculat_delta(s[u1],s[v1],s[u2],s[v2]);
				if (tabu[s[u1]][s[v1]]<=step && tabu[s[u2]][s[v2]]<=step)
				{
					if (delta_1<min_delta)
					{
						min_delta=delta_1;
						can_node_1[0]=i+1;
						can_node_2[0]=j;
						num_best=1;
					}
					else if (min_delta==delta_1 && num_best<100)
					{
						can_node_1[num_best]=i+1;
						can_node_2[num_best]=j;
						num_best++;
					}
				}
				else if (tabu[s[u1]][s[v1]]>step || tabu[s[u2]][s[v2]]>step)
				{
					if (min_tabu_delta>delta_1)
					{
						min_tabu_delta=delta_1;
						can_tabu_node_1[0]=i+1;
						can_tabu_node_2[0]=j;
						num_tabu_best=1;
					}
					else if (min_tabu_delta==delta_1 && num_tabu_best<100)
					{
						can_tabu_node_1[num_tabu_best]=i+1;
						can_tabu_node_2[num_tabu_best]=j;
						num_tabu_best++;
					}
				}
			}
		}
		int rand_order;
		if ((num_tabu_best>0 && min_tabu_delta+0.000000001<min_delta && (path_length + min_tabu_delta+0.00000001< best_path)) || num_best==0)
		{
			path_length+=min_tabu_delta;
			rand_order=rand()% num_tabu_best;
			reverse_1=can_tabu_node_1[rand_order];
			reverse_2=can_tabu_node_2[rand_order];
			tabu[s[(reverse_1-1)%n_v]][s[reverse_2%n_v]]=step+tabu_length+rand()%tabu_length;
			tabu[s[(reverse_2+1)%n_v]][s[reverse_1%n_v]]=step+tabu_length+rand()%tabu_length;
			reverse(s, reverse_1,reverse_2,n_v);
		}
		else
		{
			path_length+=min_delta;
			rand_order=rand()%num_best;
			reverse_1=can_node_1[rand_order];
			reverse_2=can_node_2[rand_order];
			tabu[s[(reverse_1-1)%n_v]][s[reverse_2%n_v]]=step+tabu_length+rand()%tabu_length;
			tabu[s[(reverse_2+1)%n_v]][s[reverse_1%n_v]]=step+tabu_length+rand()%tabu_length;
			reverse(s,reverse_1,reverse_2,n_v);
		}
		if (best_path>path_length)
		{
			best_path=path_length;
			for (int i=0;i<=n_v-1;i++)
				best_s[i]=s[i];
			no_improve=0;
		}
		else
			no_improve++;
		if (n_v<10)
		{
			if (no_improve>=5)//10
				break;
			if (step>50)
				break;
		}
		else
		{
			if (no_improve>(n_v))//10   an important parameters
			break;
			if (step>n_v*5*10)
				break;
		}
	}
	int k;
	for (int i=0;i<=n_v-1;i++)
		if (best_s[i]==0)
		{	k=i;break;}
	s[0]=0;int c=1;
	for (int j=k+1;best_s[j%n_v]!=0;j++)
	{
		s[c]=best_s[j%n_v];c++;
	}
	return best_path;
}
void opt_2(solution & pi,int * record_table,int ** tabu,solution & tem_pi)
{
	int count;
	double current_cost=0;
//	solution tem_pi;
	tem_pi.fit=pi.fit;
//	tem_pi.sol=new int * [v_num];
//	int ** tem_re;
//	tem_re=new int *[v_num];
//	for (int i=0;i<=v_num-1;i++)
//	{
//		tem_pi.sol[i]=new int [num_v+1];
//		tem_re[i]=new int [num_v+1];
//	}
	for (int i=0;i<=v_num-1;i++)
		for (int j=0;j<=num_v;j++)
		{
			tem_pi.sol[i][j]=pi.sol[i][j];
			tem_pi.sol_r[i][j]=pi.sol_r[i][j];
		}
	vector<int> tour;int pointer;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=0;
		while (1)
		{
			tour.push_back(pointer);
			pointer=tem_pi.sol[i][pointer];
			if (pointer==0)break;
		}
		count=tour.size();
		int sub_sol[count];
		for (int p=0;p<count;p++)
		{
			sub_sol[p]=tour[p];
		}
		tour.erase(tour.begin(),tour.end());
		if (record_table[i]==0)
		{
			current_cost+=calculate_length_tour(sub_sol,count);
			continue;
		}
		else
			record_table[i]=0;	
		if ((rand()%100)>choose_prob_intra)
			current_cost+=tabu_search_2_opt(sub_sol,count);
		else
			current_cost+=tabu_search_2(sub_sol,count, tabu);
		pointer=0;
		for (int j=1;j<=count-1;j++)
		{
			tem_pi.sol[i][pointer]=sub_sol[j];
			pointer=tem_pi.sol[i][pointer];
		}
		tem_pi.sol[i][pointer]=0;
		pointer=0;
		for (int j=count-1;j>=1;j--)
		{
			tem_pi.sol_r[i][pointer]=sub_sol[j];
			pointer=tem_pi.sol_r[i][pointer];
		}
		tem_pi.sol_r[i][pointer]=0;
	}
	if (current_cost<pi.fit)
	{
		pi.fit=current_cost;
		for (int i=0;i<=v_num-1;i++)
			for (int j=0;j<=num_v;j++)
			{
				pi.sol[i][j]=tem_pi.sol[i][j];
				pi.sol_r[i][j]=tem_pi.sol_r[i][j];
			}
	}
//	for (int i=0;i<=v_num-1;i++)
//	{
//		delete [] tem_pi.sol[i];
//		delete [] tem_re[i];
//	}
//	delete [] tem_pi.sol;
//	delete [] tem_re;
}
void initial_delta(double **delta_zero, double **delta_insert,int *s_t,solution &pi)
{
	for(int i=0;i<=v_num-1;i++)
		for(int j=0;j<=num_v;j++)
			delta_zero[i][j]=Max;
	for (int i=0;i<=num_v;i++)
		for (int j=0;j<=num_v;j++)
			delta_insert[i][j]=Max;
	int pointer;
	for (int j=1;j<=num_v;j++)
	{
		if (x_y[j]>0)
			continue;
		for (int k=0;k<=v_num-1;k++)
		{
			if (k==s_t[j])// when the order of tour is same with it's own, it just skips.
				continue;
			pointer=0;
			while (1)
			{
				if (pointer==0)
				{
					delta_zero[k][j]=Distance[0][j]+Distance[j][pi.sol[k][pointer]]-Distance[0][pi.sol[k][pointer]];
					delta_zero[k][j]+=Distance[pi.sol[s_t[j]][j]][pi.sol_r[s_t[j]][j]]-Distance[pi.sol[s_t[j]][j]][j]-Distance[pi.sol_r[s_t[j]][j]][j];
					pointer=pi.sol[k][pointer];
					continue;
				}
				delta_insert[pointer][j]=Distance[j][pi.sol[k][pointer]]+Distance[pointer][j]-Distance[pointer][pi.sol[k][pointer]];
				delta_insert[pointer][j]+=Distance[pi.sol[s_t[j]][j]][pi.sol_r[s_t[j]][j]]-Distance[j][pi.sol[s_t[j]][j]]-Distance[pi.sol_r[s_t[j]][j]][j];
				pointer=pi.sol[k][pointer];
				if (pointer==0)
					break;
			}
		}
	}
}
long int comput_tabu1(solution & pi)
{
	long int sum=0;long int tour;int p;
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;tour=0;
		while (1)
		{
			tour+=pi.sol[i][p];
			p=pi.sol[i][p];
			if (p==0)
				break;
		}
		tour=tour*(i+1);
		sum+=tour;
	}
	return sum;
}
long int comput_tabu2(solution &pi)
{
	long int sum=0;int p;
	for(int i=0;i<=v_num-1;i++)
	{
		p=pi.sol[i][0];
		while(1)
		{
			if (pi.sol[i][p]==0)
				break;
			sum+=p*pi.sol[i][p];
			p=pi.sol[i][p];
		}
	}
	return sum;
}
long int comput_tabu1_part(solution & pi, int *s_t,int row,int col,int in_num)
{
	long int change=0;
	change=change + in_num*(row+1)-in_num*(s_t[in_num]+1);
	return change;
}
long int comput_tabu2_part(solution & pi, int * s_t,int row, int col, int in_num)
{
	long int change=0;
	change=change+in_num*col+in_num*pi.sol[row][col]-col*pi.sol[row][col];
	change=change+pi.sol_r[s_t[in_num]][in_num]*pi.sol[s_t[in_num]][in_num]-pi.sol_r[s_t[in_num]][in_num]*in_num-pi.sol[s_t[in_num]][in_num]*in_num;
	return change;
}
void loacl_improve(solution & pi, solution & best_p,int * Hx1,int *Hx2,double ** delta_insert,double ** delta_zero,int ** tabu,
	int *s_t,clock_t start,int time_length,solution & tem_pi)
{
	int pointer;int p_pointer,n_pointer;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=pi.sol[i][0];
		while (pointer!=0)
		{
			s_t[pointer]=i;
			pointer=pi.sol[i][pointer];
		}
	}
	int record_table[v_num];
	for (int i=0;i<=v_num-1;i++)// where all tours need to be optimized 
		record_table[i]=1;
	opt_2(pi,record_table,tabu,tem_pi);
	long int Hx11,Hx22,Hx111,Hx222;
	for (int i=0;i<=Max_length-1;i++)
	{
		Hx1[i]=0;Hx2[i]=0;
	}
	Hx11=comput_tabu1(pi);
	Hx22=comput_tabu2(pi);
	double min_delta;double min_tabu_delta;
	int in_num,row,col;
	initial_delta(delta_zero,delta_insert,s_t,pi);
	int step=0;
	int can_node_1[100];int can_node_2[100];int loction[100];// where the location is used to save the inserting location for all nodes
	int num_best,num_tabu_best;
	int can_tabu_node_1[100];int can_tabu_node_2[100];int loction_tabu[100];
	int no_improve=0;
	while (1)// enter the tabu search loop
	{
		min_delta=Max;num_best=0;num_tabu_best=0;min_tabu_delta=Max;
		for (int i=0;i<=v_num-1;i++)
		{
			pointer=0;
			while (1)
			{
				if (pointer==0)// extract delta_zero
				{
					for (int j=record;j<=num_v;j++)// carry all inserting nodes
					{
						if (s_t[j]==i)
							continue;
						if (x_y[j]>0)
							continue;
						else
						{
							Hx111=Hx11+comput_tabu1_part(pi,s_t,i,pointer,j);
							Hx222=Hx22+comput_tabu2_part(pi,s_t,i,pointer,j);
							if (Hx1[Hx111%Max_length]==1 && Hx2[Hx222%Max_length]==1)
							{
								if (delta_zero[i][j]<min_tabu_delta)
								{
									min_tabu_delta=delta_zero[i][j];
									can_tabu_node_1[0]=i;
									loction_tabu[0]=pointer;
									can_tabu_node_2[0]=j;
									num_tabu_best=1;
								}
								else if ((min_tabu_delta+1.0e-7>delta_zero[i][j]) && (min_tabu_delta-1.0e-7<delta_zero[i][j]) && num_tabu_best<100)
								{
									can_tabu_node_1[num_tabu_best]=i;
									loction_tabu[num_tabu_best]=pointer;
									can_tabu_node_2[num_tabu_best]=j;
									num_tabu_best++;
								}
							}
							else
							{
								if (delta_zero[i][j]<min_delta)
								{
									min_delta=delta_zero[i][j];
									can_node_1[0]=i;
									loction[0]=pointer;
									can_node_2[0]=j;
									num_best=1;
								}
								else if ((delta_zero[i][j]+1.0e-7>min_delta) && (delta_zero[i][j]-1.0e-7<min_delta) && num_best<100)
								{
									can_node_1[num_best]=i;
									loction[num_best]=pointer;
									can_node_2[num_best]=j;
									num_best++;
								}
							}
						}
					}
				}
				else
				{
					for (int j=record;j<=num_v;j++)// carry all inserting nodes
					{
						if (s_t[j]==i)
							continue;
						if (x_y[j]>0)
							continue;
						else
						{
							Hx111=Hx11+comput_tabu1_part(pi,s_t,i,pointer,j);
							Hx222=Hx22+comput_tabu2_part(pi,s_t,i,pointer,j);
							if (Hx1[Hx111%Max_length]==1 && Hx2[Hx222%Max_length]==1)
							{
								if (delta_insert[pointer][j]<min_tabu_delta)
								{
									min_tabu_delta=delta_insert[pointer][j];
									can_tabu_node_1[0]=i;
									loction_tabu[0]=pointer;
									can_tabu_node_2[0]=j;
									num_tabu_best=1;
								}
								else if (min_tabu_delta+1.0e-7>delta_insert[pointer][j] && min_tabu_delta-1.0e-7<delta_insert[pointer][j] && num_tabu_best<100)
								{
									can_tabu_node_1[num_tabu_best]=i;
									loction_tabu[num_tabu_best]=pointer;
									can_tabu_node_2[num_tabu_best]=j;
									num_tabu_best++;
								}
							}
							else
							{
								if (delta_insert[pointer][j]<min_delta)
								{
									min_delta=delta_insert[pointer][j];
									can_node_1[0]=i;
									loction[0]=pointer;
									can_node_2[0]=j;
									num_best=1;
								}
								else if (delta_insert[pointer][j]+1.0e-7>min_delta && delta_insert[pointer][j]-1.0e-7<min_delta && num_best<100)
								{
									can_node_1[num_best]=i;
									loction[num_best]=pointer;
									can_node_2[num_best]=j;
									num_best++;
								}
							}
						}
					}
				}
				pointer=pi.sol[i][pointer];
				if (pointer==0)
					break;
			}
		}
		int rand_order;
		if ((num_tabu_best>0 && min_tabu_delta+0.000000001<min_delta && (pi.fit + min_tabu_delta+0.00000001<best_p.fit)) || num_best==0)
		{
			pi.fit+=min_tabu_delta;
			rand_order=rand()%num_tabu_best;
			row=can_tabu_node_1[rand_order];
			col=loction_tabu[rand_order];
			in_num=can_tabu_node_2[rand_order];
		}
		else
		{
			pi.fit+=min_delta;
			rand_order=rand()%num_best;
			row=can_node_1[rand_order];
			col=loction[rand_order];
			in_num=can_node_2[rand_order];
		}
		Hx11+=comput_tabu1_part(pi,s_t,row,col,in_num);
		Hx22+=comput_tabu2_part(pi,s_t,row,col,in_num);
		Hx1[Hx11%Max_length]=1;
		Hx2[Hx22%Max_length]=1;
		record_table[row]=1;
		record_table[s_t[in_num]]=1;
		if (col==0)
		{
			insert_zero(pi,row,in_num,s_t,p_pointer,n_pointer);
		}
		if (col>0)// need to consider that the in_num is the last number
		{
			insert_f(pi,row,col,in_num,s_t,p_pointer,n_pointer);
		}
		update_zero_delta(pi,row,col,in_num,s_t,p_pointer,n_pointer,delta_insert,delta_zero,record);
		if (pi.fit<best_p.fit)
		{
			update_best_sol(pi,best_p);no_improve=0;
		}
		else
			no_improve++;
		if ((double(rand()%100))<((double(v_num))))
		{
			opt_2(pi,record_table,tabu,tem_pi);
			initial_delta(delta_zero,delta_insert,s_t,pi);
			Hx22=comput_tabu2(pi);
		}
//		cout<<step<<"    "<<pi.fit<<"      "<<best_p.fit<<endl;
		step++;
		if (no_improve>depth_of_SbTS || (ceil((clock() - start)/static_cast<double>(CLOCKS_PER_SEC))>=time_length))
			break;
	}
}
void main_search(solution &pi,solution &best_p,solution & g_best_p,int *Hx1,int * Hx2,clock_t start, int time_length,
	clock_t & optimal_time,double ** delta_insert,double ** delta_zero,int ** tabu,solution & tem_pi)
{
	reverse_list(pi);// generate the reverse solution for pi.
	int sequence_table[num_v+1];int no_improve=0;
	int step=0;
	while (1)
	{
		loacl_improve(pi,best_p,Hx1,Hx2,delta_insert,delta_zero,tabu,sequence_table,start,time_length,tem_pi);// the first phase
		// update the optimal solution
		cout<<step<<"      "<<best_p.fit<<"          "<<g_best_p.fit<<endl;
		if (best_p.fit<g_best_p.fit)
		{
			update_best_sol(best_p,g_best_p);
			no_improve=0;
		}
		else
			no_improve++;
		re_construction(pi,best_p,no_improve);
		if(ceil((clock() - start)/static_cast<double>(CLOCKS_PER_SEC))>=time_length)
				break;
		step++;
	}
}


