/*
 * perturba_fun.cpp

 *
 *  Created on: Jan 8, 2020
 *      Author: pengfei
 */
#include"basic.h"
#include"read.h"
#include "local_search.h"
using namespace std;
extern int ex;
extern int num_v;
extern int v_num;
extern double ** Distance;
extern int *x_y;
extern int iterations;
extern int record;
// how to implement the BLS into this framework

void re_construction(solution &pi,solution &best_p,int no_improve)
{
	int row;int p;int p_n;int p_p;
	int s_t[num_v+1];// this table is used to keep which node belongs to which tour;
	double prob;
	double d = static_cast<double>(no_improve)/control_para;
	double e=pow(2.718,-d);
	prob=1-e/2;
	for (int i=0;i<=v_num-1;i++)
	{
		p=pi.sol[i][0];
		while (p!=0)
		{
			s_t[p]=i;
			p=pi.sol[i][p];
		}
	}
	vector<int>unassign;
	for (int i=record-1;i<=num_v;i++)
	{
		if (x_y[i]>0)
			continue;
		else
		{
			if (((rand()%100)/100.0)<prob)
			{
				row=s_t[i];
				unassign.push_back(i);
				p_n=pi.sol[row][i];
				p_p=pi.sol_r[row][i];
				pi.sol[row][p_p]=p_n;
				pi.sol[row][i]=-1;
				pi.sol_r[row][p_n]=p_p;
				pi.sol_r[row][i]=-1;
			}
		}
	}// complete extracting all nodes
	random_shuffle(unassign.begin(), unassign.end());// random all nodes in unassign
	double delta,tem;
	int loc,n_t;
	int length=unassign.size();
	for (int i=0;i<=length-1;i++)
	{
		delta=Max;
		for (int j=0;j<=v_num-1;j++)
		{
			p=0;
			while (1)
			{
				tem=Distance[p][unassign[i]]+Distance[unassign[i]][pi.sol[j][p]]-Distance[p][pi.sol[j][p]];
				if (tem<delta &&  (rand()%100 >accept_pro_perb))
				{
					delta=tem;
					row=j;
					loc=p;
				}
				p=pi.sol[j][p];
				if (p==0)
					break;
			}
		}
		n_t=pi.sol[row][loc];
		pi.sol[row][loc]=unassign[i];
		pi.sol[row][unassign[i]]=n_t;
		pi.sol_r[row][n_t]=unassign[i];
		pi.sol_r[row][unassign[i]]=loc;
	}
	pi.fit=0;
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;
		while (1)
		{
			pi.fit+=Distance[p][pi.sol[i][p]];
			p=pi.sol[i][p];
			if (p==0)
				break;
		}
	}
	update_best_sol(pi,best_p);
}



