#include"basic.h"
#include"read.h"
#include <fstream>
using namespace std;
extern int ex;
extern int num_v;
extern int v_num;
extern int *x_y;// this variable is used to save the coordination of all nodes and characteristics which means which nodes could be visited by vehicles.
extern double ** Distance;
int build_instance(char *file_name)
{
	ifstream open_file(file_name);
	x_y=new int [num_v+1];// the first and second colmun is used to save the coordinate and the third is used to save the characteristics
	for (int i=0;i<=num_v;i++)
		x_y[i]=0;
	char aa[1000];
	open_file>>aa;
	int num;
	while (1)
	{
		open_file>>num;
		if (num==num_v)
		{
			open_file>>v_num;open_file>>ex;
			break;
		}
	}
	int count=1;int iden=1;
	for (int i=1;i<=num_v;)
	{
		if (count<=ex)
		{
			x_y[i]=iden;count++;i++;
		}
		else
		{
			count=1;iden++;
		}
		if (i>ex*v_num)
			break;
	}
	int c;double x[num_v+1];double y[num_v+1];    //
	for (int i=0;i<=num_v;i++)                                            //
	{
		open_file>>c;open_file>>x[i];open_file>>y[i];//
	}
	open_file.close();                                                               //
	Distance =new double * [num_v+1];
	for (int i=0;i<=num_v;i++)
		Distance[i]=new double [num_v+1];
	if (num_v<=200 || (num_v>900 && num_v<5000)){
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++)
					Distance[i][j]=sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
	}
	if (num_v>5000){
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++)
				Distance[i][j]=ceil(sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j])));
	}
	if (num_v>200 && num_v<700){
		double q1,q2,q3;
		double RRR = 6378.388;
		double latitude[num_v+1];
		double longitude[num_v+1];
		double min;
		double deg;
		double PI=3.141592;
		for (int i=0;i<=num_v;i++){
			deg=int(x[i]);
			min=x[i]-deg;
			latitude[i]=PI * (deg + 5.0 * min / 3.0 ) / 180.0;
			deg=int(y[i]);
			min=y[i]-deg;
			longitude[i]=PI * (deg + 5.0 * min / 3.0 ) / 180.0;
		}
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++){
				q1 = cos( longitude[i] - longitude[j] );
				q2 = cos( latitude[i] - latitude[j] );
				q3 = cos( latitude[i] + latitude[j] );
				Distance[i][j] = (int) ( RRR * acos( 0.5*((1.0+q1)*q2 - (1.0-q1)*q3) ) + 1.0);
			}
	}
	return 1;
}
void initial_population( solution &p, solution & best_p,solution & g_best_p)
{
	p.sol=new int *[v_num];
	p.sol_r=new int *[v_num];
	best_p.sol=new int *[v_num];// these solution does not have reverse solution
	g_best_p.sol=new int *[v_num];
	for (int j=0;j<=v_num-1;j++)
	{
		p.sol[j]=new int [num_v+1];
		p.sol_r[j]=new int [num_v+1];
		best_p.sol[j]=new int [num_v+1];
		g_best_p.sol[j]=new int [num_v+1];
	}
}
void output_function(solution & g_best_p,int seed,clock_t & optimal_time)
{
	int pointer;
	char name_instance[100]={0};
	sprintf(name_instance, "%d", num_v+1);
	int size=strlen (name_instance);
	name_instance[size]='_';
	size=strlen( name_instance);
	char num_vehcile[10];
	sprintf(num_vehcile, "%d", v_num);
	int size_1=strlen(num_vehcile);
	for (int i=0;i<=size_1-1;i++)
	{
		name_instance[size]=num_vehcile[i];size++;
	}
	name_instance[size]='_';size++;
	char seed_name[10];
	sprintf(seed_name, "%d", seed);
	size_1=strlen( seed_name);
	for (int i=0;i<=size_1-1;i++)
	{
		name_instance[size]=seed_name[i];size++;
	}
	char tx[4]={'.','t','x','t'};
	for (int i=0;i<=3;i++)
	{
		name_instance[size]=tx[i];size++;
	}
	ofstream out (name_instance);
	out<<"the best solution's fitness is "<<endl<<g_best_p.fit<<endl;
	//out<< "the time get the best solution is "<<endl<<optimal_time<<endl;
	out<<"the sequence of best solution is following"<<endl;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=0;
		while (1)
		{
			out<<pointer<<" ";
			pointer=g_best_p.sol[i][pointer];
			if (pointer==0)
				break;
		}
		out<<endl;
	}
	out<<endl;
	double cost=0;int p;
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;
		while (1)
		{
			cost+=Distance[p][g_best_p.sol[i][p]];
			if (g_best_p.sol[i][p]==0)
				break;
			p=g_best_p.sol[i][p];
		}
	}
	out<<"the actuall costs is "<<cost<<endl;
}
void single_solution(solution & pi,solution & best_p)
{
	for (int i=0;i<=v_num-1;i++)
		for (int j=0;j<=num_v;j++)
		{
			pi.sol[i][j]=-1;
			best_p.sol[i][j]=-1;
		}
	vector < int > node;
	int pointer;int pos;
	double delta;
	int loc;int num_nodes;int tem;double delta_tem;int rand1,rand2;
	for (int i=0;i<=v_num-1;i++)
	{
		for (int j=1;j<=num_v;j++)//
		{
			if (x_y[j]==(i+1))
				node.push_back(j);
		}
		num_nodes=node.size();
		for (int j=0;j<=num_nodes-1;j++){
			rand1=rand()%num_nodes;
			rand2=rand()%num_nodes;
			while (rand1==rand2){
				rand2=rand()%num_nodes;
			}
			tem=node[rand1];
			node[rand1]=node[rand2];
			node[rand2]=tem;
		}
		pos=rand()%(node.size());
		pi.sol[i][0]=node[pos];
		pointer=pi.sol[i][0];// pointer is employed to recored the location of the next index in this array.
		pi.sol[i][pointer]=0;
		node.erase(node.begin()+pos);
		while (node.size())
		{
			delta=Max;
			num_nodes=node.size();
			pointer=0;
			while (1){
				delta_tem=Distance[pointer][node[0]]+Distance[node[0]][pi.sol[i][pointer]]-
					Distance[pointer][pi.sol[i][pointer]];
				if (delta>delta_tem){
					delta=delta_tem;
					loc=pointer;
				}
				pointer=pi.sol[i][pointer];
				if(pointer==0)
					break;
			}
			tem=pi.sol[i][loc];
			pi.sol[i][loc]=node[0];
			pi.sol[i][node[0]]=tem;
			node.erase(node.begin()+0);
		}
	}

	for (int i=1;i<=num_v;i++)
		if (x_y[i]==0)
			node.push_back(i);
	num_nodes=node.size();
	for (int j=0;j<=num_nodes-1;j++){
		rand1=rand()%num_nodes;
		rand2=rand()%num_nodes;
		while (rand1==rand2){
			rand2=rand()%num_nodes;
		}
		tem=node[rand1];
		node[rand1]=node[rand2];
		node[rand2]=tem;
	}
	int row;
	while (node.size())
	{
		delta=Max;
		for (int i=0;i<=v_num-1;i++)
		{
			pointer=0;
			while (1)
			{
				delta_tem=Distance[node[0]][pointer]+Distance[node[0]][pi.sol[i][pointer]]-
					Distance[pointer][pi.sol[i][pointer]];
				//if (delta>delta_tem){
				if (rand()%100 >accept_pro_initial && delta>delta_tem){
					delta=delta_tem;
					pos=pointer;
					row=i;
				}
				pointer=pi.sol[i][pointer];
				if (pointer==0)
					break;
			}
		}
		tem=pi.sol[row][pos];
		pi.sol[row][pos]=node[0];
		pi.sol[row][node[0]]=tem;

		node.erase(node.begin()+0);
	}
	pi.fit=0;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=0;
		while (1)
		{
			pi.fit+=Distance[pi.sol[i][pointer]][pointer];
			pointer=pi.sol[i][pointer];
			if (pointer==0)
				break;
		}
	}
}

